diff --git a/libglusterfs/src/monitoring.c b/libglusterfs/src/monitoring.c
index d49022be688..ed0de942f6d 100644
--- a/libglusterfs/src/monitoring.c
+++ b/libglusterfs/src/monitoring.c
@@ -133,15 +133,13 @@ dump_inode_stats(glusterfs_ctx_t *ctx, int fd)
 static void
 dump_global_metrics(glusterfs_ctx_t *ctx, int fd)
 {
-    struct timeval tv;
     time_t nowtime;
     struct tm *nowtm;
     char tmbuf[64] = {
         0,
     };
 
-    gettimeofday(&tv, NULL);
-    nowtime = tv.tv_sec;
+    nowtime = gf_time();
     nowtm = localtime(&nowtime);
     strftime(tmbuf, sizeof tmbuf, "%Y-%m-%d %H:%M:%S", nowtm);
 
diff --git a/rpc/rpc-lib/src/rpc-clnt-ping.c b/rpc/rpc-lib/src/rpc-clnt-ping.c
index c8b212bc0e1..0cbfe5965e2 100644
--- a/rpc/rpc-lib/src/rpc-clnt-ping.c
+++ b/rpc/rpc-lib/src/rpc-clnt-ping.c
@@ -107,9 +107,7 @@ rpc_clnt_ping_timer_expired(void *rpc_ptr)
     rpc_transport_t *trans = NULL;
     rpc_clnt_connection_t *conn = NULL;
     int disconnect = 0;
-    struct timespec current = {
-        0,
-    };
+    time_t current = 0;
     int unref = 0;
 
     rpc = (struct rpc_clnt *)rpc_ptr;
@@ -121,14 +119,13 @@ rpc_clnt_ping_timer_expired(void *rpc_ptr)
         goto out;
     }
 
-    timespec_now_realtime(&current);
+    current = gf_time();
     pthread_mutex_lock(&conn->lock);
     {
         unref = rpc_clnt_remove_ping_timer_locked(rpc);
 
-        if (((current.tv_sec - conn->last_received.tv_sec) <
-             conn->ping_timeout) ||
-            ((current.tv_sec - conn->last_sent.tv_sec) < conn->ping_timeout)) {
+        if (((current - conn->last_received) < conn->ping_timeout) ||
+            ((current - conn->last_sent) < conn->ping_timeout)) {
             gf_log(trans->name, GF_LOG_TRACE,
                    "ping timer expired but transport activity "
                    "detected - not bailing transport");
diff --git a/rpc/rpc-lib/src/rpc-clnt.c b/rpc/rpc-lib/src/rpc-clnt.c
index 143d120dce6..8f305d099ed 100644
--- a/rpc/rpc-lib/src/rpc-clnt.c
+++ b/rpc/rpc-lib/src/rpc-clnt.c
@@ -22,15 +22,14 @@
 void
 rpc_clnt_reply_deinit(struct rpc_req *req, struct mem_pool *pool);
 
-struct saved_frame *
-__saved_frames_get_timedout(struct saved_frames *frames, uint32_t timeout,
-                            struct timeval *current)
+static struct saved_frame *
+__saved_frames_get_timedout(struct saved_frames *frames, time_t latest)
 {
     struct saved_frame *bailout_frame = NULL, *tmp = NULL;
 
     if (!list_empty(&frames->sf.list)) {
         tmp = list_entry(frames->sf.list.next, typeof(*tmp), list);
-        if ((tmp->saved_at.tv_sec + timeout) <= current->tv_sec) {
+        if (tmp->saved_at <= latest) {
             bailout_frame = tmp;
             list_del_init(&bailout_frame->list);
             frames->count--;
@@ -71,7 +70,7 @@ __saved_frames_put(struct saved_frames *frames, void *frame,
     saved_frame->capital_this = THIS;
     saved_frame->frame = frame;
     saved_frame->rpcreq = rpcreq;
-    gettimeofday(&saved_frame->saved_at, NULL);
+    saved_frame->saved_at = gf_time();
     memset(&saved_frame->rsp, 0, sizeof(rpc_transport_rsp_t));
 
     if (_is_lock_fop(saved_frame))
@@ -91,7 +90,7 @@ call_bail(void *data)
     rpc_transport_t *trans = NULL;
     struct rpc_clnt *clnt = NULL;
     rpc_clnt_connection_t *conn = NULL;
-    struct timeval current;
+    time_t current;
     struct list_head list;
     struct saved_frame *saved_frame = NULL;
     struct saved_frame *trav = NULL;
@@ -124,7 +123,7 @@ call_bail(void *data)
     if (!trans)
         goto out;
 
-    gettimeofday(&current, NULL);
+    current = gf_time();
     INIT_LIST_HEAD(&list);
 
     pthread_mutex_lock(&conn->lock);
@@ -150,7 +149,7 @@ call_bail(void *data)
 
         do {
             saved_frame = __saved_frames_get_timedout(
-                conn->saved_frames, conn->frame_timeout, &current);
+                conn->saved_frames, current - conn->frame_timeout);
             if (saved_frame)
                 list_add(&saved_frame->list, &list);
 
@@ -163,8 +162,8 @@ call_bail(void *data)
 
     list_for_each_entry_safe(trav, tmp, &list, list)
     {
-        gf_time_fmt_tv(frame_sent, sizeof frame_sent, &trav->saved_at,
-                       gf_timefmt_FT);
+        gf_time_fmt(frame_sent, sizeof frame_sent, trav->saved_at,
+                    gf_timefmt_FT);
 
         gf_log(conn->name, GF_LOG_ERROR,
                "bailing out frame type(%s), op(%s(%d)), xid = 0x%x, "
@@ -322,7 +321,7 @@ saved_frames_unwind(struct saved_frames *saved_frames)
 
     list_for_each_entry_safe(trav, tmp, &saved_frames->sf.list, list)
     {
-        gf_time_fmt_tv(timestr, sizeof timestr, &trav->saved_at, gf_timefmt_FT);
+        gf_time_fmt(timestr, sizeof timestr, trav->saved_at, gf_timefmt_FT);
 
         if (!trav->rpcreq || !trav->rpcreq->prog)
             continue;
@@ -920,7 +919,7 @@ rpc_clnt_notify(rpc_transport_t *trans, void *mydata,
         }
 
         case RPC_TRANSPORT_MSG_RECEIVED: {
-            timespec_now_realtime(&conn->last_received);
+            conn->last_received = gf_time();
 
             pollin = data;
             if (pollin->is_reply)
@@ -934,7 +933,7 @@ rpc_clnt_notify(rpc_transport_t *trans, void *mydata,
         }
 
         case RPC_TRANSPORT_MSG_SENT: {
-            timespec_now_realtime(&conn->last_sent);
+            conn->last_sent = gf_time();
             ret = 0;
             break;
         }
diff --git a/rpc/rpc-lib/src/rpc-clnt.h b/rpc/rpc-lib/src/rpc-clnt.h
index ba6a1796e85..73ae641f501 100644
--- a/rpc/rpc-lib/src/rpc-clnt.h
+++ b/rpc/rpc-lib/src/rpc-clnt.h
@@ -53,7 +53,7 @@ struct saved_frame {
     void *capital_this;
     void *frame;
     struct rpc_req *rpcreq;
-    struct timeval saved_at;
+    time_t saved_at;
     rpc_transport_rsp_t rsp;
 };
 
@@ -135,8 +135,8 @@ struct rpc_clnt_connection {
     gf_timer_t *ping_timer;
     struct rpc_clnt *rpc_clnt;
     struct saved_frames *saved_frames;
-    struct timespec last_sent;
-    struct timespec last_received;
+    time_t last_sent;
+    time_t last_received;
     uint64_t pingcnt;
     uint64_t msgcnt;
     uint64_t cleanup_gen;
